/* 
 *
 * Copyright (c) <2010> Comarch S.A. and/or its subsidiary(-ies).
 * All rights reserved.
 * This component and the accompanying materials are made available
 * under the terms of the License "Eclipse Public License v1.0"
 * which accompanies this distribution, and is available
 * at the URL "http://www.eclipse.org/legal/epl-v10.html".
 *
 * Original Contributors:
 * Comarch S.A. - original contribution.
 *
 * Contributors:
 *
 * Description:
 *
 */

#ifndef __HSPPROFILE_H__
#define __HSPPROFILE_H__

#include <e32base.h>    
#include <e32std.h>
#include <hsprofilepluginbase.h>

class CHsHSPDataHandler;
class CHsHSPSettings;

/** HSP Ecom implementation Uid */
const TUid KHsHSPProfileImplementationUid =
    {
    0xE0009DC7
    };


/**
 * @brief Implementation of Headset profile
 */
class CHsHSPProfile : public CHsProfileBase
{
public:
    /**
     * Two-phase constructor
     * @return instance of class
     */
    static CHsHSPProfile* NewL();

    /**
     * Two-phase constructor
     * @return instance of class
     */
    static CHsHSPProfile* NewLC();

    /**
     * Destructor
     */
    ~CHsHSPProfile();

public:
    // Methods derived from MHsProfileBase
    void HandleCommandL( const TDesC8 &aCommandsIn, TDes8 &aCommandsOut,
            const TBool aFromAG = ETrue );

    void HandleClientDisconnected( TInt aErr );

    void HandleClientConnected( TDes8& aCommandOut );

    void HandleAcceptCallL( TDes8& aCommandOut );

    void HandleReleaseCallL( TDes8& aCommandOut );

private:
    /**
     * Constructor for performing 1st stage construction
     */
    CHsHSPProfile();

    /**
     * Constructor for performing 2nd stage construction
     */
    void ContructL();

private:
    /** AT command handler. Owned */
    CHsHSPDataHandler* iDataHandler;

    /**  Profile's settings   */
    CHsHSPSettings* iSettings;
};

#endif  // __HSPPROFILE_H__
